/*
 * pBSPNode.java
 *
 * (C) 2005, Alex S.
 */
 
import java.util.*;

/**
 * the bsp tree node
 */
public class pBSPNode {
    public int type = 0;
    public static final int TREENODE = 0;
    public static final int LEAFNODE = 1;

    public pPlane plane = new pPlane();
    public pBSPNode front = null;
    public pBSPNode back = null;

    public int frontidx = -1;
    public int backidx = -1;
    public int firstface = -1;
    public int numfaces = 0;

    public int[] brushidx = null;

    // faces that are on this node.
    public Vector faces = new Vector();

    public Vector brushes = new Vector();

    public pBSPNode(){
        type = TREENODE;
    }
    public pBSPNode(int type){
        this.type = type;
    }
    
    // read the winding
    public static pBSPNode read(java.io.StreamTokenizer st) throws java.io.IOException {       
        pBSPNode n = new pBSPNode(TREENODE);
        n.plane = pPlane.read(st);
        st.nextToken();
        n.frontidx = (int)st.nval;
        st.nextToken();
        n.backidx = (int)st.nval;
        st.nextToken();
        n.firstface = (int)st.nval;
        st.nextToken();
        n.numfaces = (int)st.nval; 
        return n;
    }

    // read the winding
    public static pBSPNode readLeaf(java.io.StreamTokenizer st) throws java.io.IOException {       
        pBSPNode l = new pBSPNode(LEAFNODE);
        st.nextToken();
        l.brushidx = new int[(int)st.nval];
        for(int i=0;i<l.brushidx.length;i++){
            st.nextToken();
            l.brushidx[i] = (int)st.nval;
        }
        return l;
    }
}


